--Configuration Variables
local partyMembers = 0
local unit
local achID
local isReady = false
local currentUnit
local unitName
local currentPlayer
local currentGroup
local tableOfPlayers = {}
local constructorTable = {}
local checkTheOverall = {}
local maxAch = 31

--frame
Meta = CreateFrame("Frame", "MetaFrame", UIParent)

--moving
Meta:SetScript("OnMouseDown", Meta.StartMoving)
--stop moving
Meta:SetScript("OnMouseUp", Meta.StopMovingOrSizing)

--Importent Event
Meta:RegisterEvent("INSPECT_ACHIEVEMENT_READY")

--Global Tables
currentAch = {}
theList = {}
--Functions

--Called From Menu Options by pressing the button in runButton:SetScript
--Makes the first tab that is used for Everyone
function Meta:makeTable()
	Meta:Show()
	unitName = "Everyone"
	currentUnit = "Everyone"
	currentPlayer = 255
	Meta:personalTab() --Makes a tab that is either complete or not complete if all people are done 1, or if even 1 is not complete
	Meta:initCheck(0)
	local reportButton = CreateFrame("Button", "metaRunButton", tableOfPlayers[currentPlayer], "UIPanelButtonTemplate")
	reportButton:SetWidth(110)
	reportButton:SetHeight(20)
	reportButton:SetPoint("TOPLEFT", 16, -16) 
	reportButton:SetText("Report")
	
	reportButton:SetScript("OnClick", function(frame)
		Meta:report(0)
	end)
end

--called from Meta:makeTable
--Reports to chat how many are missing the achieve
function Meta:report(a)
	local current = a
	if(current < currentAch[1]) then
		local compare = GetNumGroupMembers() - checkTheOverall[current]
		if(compare ~= 0) then
			local dump1, name = GetAchievementInfo(theList[current])
			print(compare..": People are missing "..name)
		end
		Meta:report(current+1)
	end
end

--Called from Meta:makeTable 
--Clears all the values that are used to check if everyone has it done
function Meta:initCheck(a)
	local loop = a
	if(loop<maxAch) then
		checkTheOverall[loop] = 0
		Meta:initCheck(loop+1)
	end
end

--Called from MenuOptions.lua by pressing the button in runButton:SetScript
--Only used to initialize a self scan
function Meta:SweepSelfDummy()
	currentUnit = "player"
	unitName = GetUnitName("player")
	currentPlayer = 0
	Meta:clearTables()
	Meta:personalTab()
	Meta:SweepSelf(0)
end

--Called from Meta:SweepSelfDummy() and Meta:setFocus()
--Reseting the personal Tabs for a smooth change between changes
function Meta:clearTables()
	Meta:clearAll(maxAch)
end

--Called from Meta:clearTables()
--Clears all the tabs that were used unless less members are in the group
function Meta:clearAll(a)
	local current = a
	if(current >= 0) then
		if constructorTable[currentPlayer] then
			if constructorTable[currentPlayer][current] then
				constructorTable[currentPlayer][current]:SetText("")
				constructorTable[currentPlayer][100][current]:SetTexture(nil)
			end
		end
		Meta:clearAll(current-1)
	end
end

--Called from Meta:SweepSelfDummy() and Meta:setFocus()
--Making a tab for each player
function Meta:personalTab()
	if not tableOfPlayers[currentPlayer] then
		local tableOfAchieves = {} --100 = The graphical X/Check. 200=Name in the Tab. 300=Current Achievement name
		local trueFalses = {}
		tableOfAchieves[100] = trueFalses
		constructorTable[currentPlayer] = tableOfAchieves
		local scan = CreateFrame( "Frame", currentUnit, InterfaceOptionsFramePanelContainer)
		tableOfPlayers[currentPlayer] = scan
		tableOfPlayers[currentPlayer]:Hide()
		tableOfPlayers[currentPlayer].parent = meta.panel.name;
		tableOfPlayers[currentPlayer].name = unitName
		InterfaceOptions_AddCategory(tableOfPlayers[currentPlayer])
	end
	Meta:nameInTab()
end

--Putting the name into the personalTab frame
--Changes name if it has changed(useless atm since it is using real name instead of groupID)
function Meta:nameInTab()
	if not constructorTable[currentPlayer][200] then
		local title = tableOfPlayers[currentPlayer]:CreateFontString(currentUnit, "ARTWORK", "GameFontNormalLarge")
		constructorTable[currentPlayer][200] = title
		constructorTable[currentPlayer][200]:SetPoint("TOP", 0, -5)
	end
	constructorTable[currentPlayer][200]:SetText(unitName)
	Meta:achieveInTab()
end

--Putting the title of the achievement in the personal Tab
--Also changes the title on achievement change
function Meta:achieveInTab()
	if not constructorTable[currentPlayer][300] then
		local achTitle = tableOfPlayers[currentPlayer]:CreateFontString(currentUnit.."1","ARTWORK","GameFontNormalLarge")
		constructorTable[currentPlayer][300]=achTitle
		constructorTable[currentPlayer][300]:SetPoint("TOP",tableOfPlayers[currentPlayer],"TOP",0,-23)
		constructorTable[currentPlayer][300]:SetText(currentAch[2])
	else
		constructorTable[currentPlayer][300]:SetText(currentAch[2])
	end
end

--Called from SweepSelfDummy()
--Used to scan the player, Using an ID of 0
function Meta:SweepSelf(a)
	local current = a
	if(current < currentAch[1]) then
		local dump1, dump2, dump3, bool = GetAchievementInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
		Meta:SweepSelf(current+1)
	end
end

--Show if everyone has the achievement
function Meta:totals()
	currentPlayer = 255
	currentUnit = "Everyone"
	unitName = "Everyone"
	Meta:clearTables()
	Meta:sweepTotal(0)
end

function Meta:sweepTotal(a)
	local current = a
	if(current < currentAch[1]) then
		if(checkTheOverall[current] >= GetNumGroupMembers()) then
			Meta:metaInTab(true,current)
		else
			Meta:metaInTab(false,current)
		end
	Meta:sweepTotal(current +1)
	end
end

--Putting the Achievements into the personalTab/overallTab frame
--Will move the words if the achievement has changed
function Meta:metaInTab(b,c)
	if(constructorTable[currentPlayer][c] == nil) then 
		local achieveText = tableOfPlayers[currentPlayer]:CreateFontString("SPGaugeConfigPopupButtonTitle", "ARTWORK", "GameFontHighlight")
		constructorTable[currentPlayer][c] = achieveText
	end
	local dump1, idd = GetAchievementInfo(currentAch[3][c])
	constructorTable[currentPlayer][c]:SetText(idd)
	if(c>=(currentAch[1]/2)) then
		constructorTable[currentPlayer][c]:SetPoint("RIGHT", tableOfPlayers[currentPlayer], "TOPRIGHT", -35, (-30*(c-(currentAch[1]/2)))-60)
	else
		constructorTable[currentPlayer][c]:SetPoint("RIGHT", tableOfPlayers[currentPlayer], "TOPLEFT", 220, (-30*c)-60)
	end
	Meta:yesNo(b,c)
end

--Putting the Yes/No check or cross
--Will change the symbol and move the symbol if the achievement has changed
function Meta:yesNo(b,c)
	if(constructorTable[currentPlayer][100][c] == nil) then
		local boolean = tableOfPlayers[currentPlayer]:CreateTexture(nil, "ARTWORK")
		constructorTable[currentPlayer][100][c] = boolean
		constructorTable[currentPlayer][100][c]:SetHeight(28)
		constructorTable[currentPlayer][100][c]:SetWidth(28)
	end
	if(c>=(currentAch[1]/2)) then
		constructorTable[currentPlayer][100][c]:SetPoint("RIGHT", tableOfPlayers[currentPlayer], "TOPRIGHT", -5, (-30*(c-(currentAch[1]/2)))-60)
	else
		constructorTable[currentPlayer][100][c]:SetPoint("RIGHT", tableOfPlayers[currentPlayer], "TOPLEFT", 250, (-30*c)-60)
	end
	if b then
		if(currentPlayer ~= 255) then
			checkTheOverall[c] = checkTheOverall[c] + 1
		end
		constructorTable[currentPlayer][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\check")
	else
		constructorTable[currentPlayer][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\Cross")
	end
end

--Checking Party Members
function Meta:PartyCheckAchieve(a,b)
	currentPlayer = a
	currentGroup = b
	if(currentPlayer > 0) then
		Meta:SetFocus(currentGroup..currentPlayer)
	end
end

--Sets up the Comparison Unit for sweeping the selected meta achievement
--Checks if they are out of range, if they are it will recall itself after it has set lables in the interface
--if the player passed is self, then it will skip it since it was already made in SweepSelfDummy()
function Meta:SetFocus(a)
	currentUnit = a
	unitName = GetUnitName(a)
	if(currentPlayer == 0 ) then
		Meta:totals()
		return;
	end
	if(unitName == GetUnitName("player")) then
		currentPlayer = currentPlayer -1
		if(currentPlayer>=0) then
			Meta:SetFocus(currentGroup..currentPlayer)
		end
		return;	
	end
	Meta:clearTables()
	Meta:personalTab()
	if(UnitInRange(currentUnit)) then
		tableOfPlayers[currentPlayer].name = unitName
		SetAchievementComparisonUnit(currentUnit)
	else
		tableOfPlayers[currentPlayer].name = ("!"..unitName)
		constructorTable[currentPlayer][200]:SetText(unitName.." :OUT OF RANGE")
		currentPlayer = currentPlayer -1
		if(currentPlayer>=0) then
			Meta:SetFocus(currentGroup..currentPlayer)
		end
	end
end

--Reports each achievement as a true/false for completion
function Meta:SweepAch(a)
	local current = a
	if(current < currentAch[1]) then
		local bool = GetAchievementComparisonInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
	Meta:SweepAch(current +1)
	end
end
	
--The Scan Script
Meta:SetScript("OnEvent", 
	function(self, event, ...)
		Meta:SweepAch(0)
		ClearAchievementComparisonUnit()
		if(currentPlayer > 1) then
			currentPlayer = currentPlayer -1
			Meta:SetFocus(currentGroup..currentPlayer)
		end
end)

